using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
//using System.Data;
using System.IO;

namespace GenerateThumbnails
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.RadioButton radioButton1;
		private System.Windows.Forms.RadioButton radioButton2;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox textBox2;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.FolderBrowserDialog folderBrowserDialog1;
		private System.Windows.Forms.ProgressBar progressBar1;
		private System.Windows.Forms.Button btnCreate;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.LinkLabel linkLabel1;
		private System.Windows.Forms.Label lblDone;

		private SizeDialog sd;



		/// <summary>
		/// Whether existing thumbnails will be overwritten or not.
		/// </summary>
		private bool refreshOldThumbnails = true;

		/// <summary>
		/// The maximum width of the thumbnail
		/// </summary>
		private int maxWidth = 80;

		/// <summary>
		/// The maximum height of the thumbnail
		/// </summary>
		private int maxHeight = 60;


		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			Application.EnableVisualStyles();
			InitializeComponent();
			sd = new SizeDialog();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.panel1 = new System.Windows.Forms.Panel();
			this.lblDone = new System.Windows.Forms.Label();
			this.linkLabel1 = new System.Windows.Forms.LinkLabel();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.progressBar1 = new System.Windows.Forms.ProgressBar();
			this.panel3 = new System.Windows.Forms.Panel();
			this.button2 = new System.Windows.Forms.Button();
			this.textBox2 = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.radioButton1 = new System.Windows.Forms.RadioButton();
			this.button1 = new System.Windows.Forms.Button();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.radioButton2 = new System.Windows.Forms.RadioButton();
			this.panel2 = new System.Windows.Forms.Panel();
			this.button4 = new System.Windows.Forms.Button();
			this.btnCreate = new System.Windows.Forms.Button();
			this.folderBrowserDialog1 = new System.Windows.Forms.FolderBrowserDialog();
			this.panel1.SuspendLayout();
			this.panel3.SuspendLayout();
			this.panel2.SuspendLayout();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel1.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel1.Controls.Add(this.lblDone);
			this.panel1.Controls.Add(this.linkLabel1);
			this.panel1.Controls.Add(this.checkBox1);
			this.panel1.Controls.Add(this.progressBar1);
			this.panel1.Controls.Add(this.panel3);
			this.panel1.Controls.Add(this.radioButton1);
			this.panel1.Controls.Add(this.button1);
			this.panel1.Controls.Add(this.textBox1);
			this.panel1.Controls.Add(this.label3);
			this.panel1.Controls.Add(this.label2);
			this.panel1.Controls.Add(this.label1);
			this.panel1.Controls.Add(this.radioButton2);
			this.panel1.Location = new System.Drawing.Point(0, 0);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(496, 354);
			this.panel1.TabIndex = 0;
			// 
			// lblDone
			// 
			this.lblDone.Location = new System.Drawing.Point(192, 328);
			this.lblDone.Name = "lblDone";
			this.lblDone.Size = new System.Drawing.Size(120, 16);
			this.lblDone.TabIndex = 10;
			this.lblDone.Text = "Done";
			this.lblDone.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			this.lblDone.Visible = false;
			// 
			// linkLabel1
			// 
			this.linkLabel1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.linkLabel1.LinkColor = System.Drawing.Color.DeepSkyBlue;
			this.linkLabel1.Location = new System.Drawing.Point(64, 296);
			this.linkLabel1.Name = "linkLabel1";
			this.linkLabel1.Size = new System.Drawing.Size(336, 16);
			this.linkLabel1.TabIndex = 9;
			this.linkLabel1.TabStop = true;
			this.linkLabel1.Text = "Click here to change the dimensions of the generated thumbnails";
			this.linkLabel1.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.linkLabel1_LinkClicked);
			// 
			// checkBox1
			// 
			this.checkBox1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.checkBox1.Location = new System.Drawing.Point(64, 264);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(216, 16);
			this.checkBox1.TabIndex = 8;
			this.checkBox1.Text = "Overwrite Exisiting Thumbnails";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.overwriteCheckChanged);
			// 
			// progressBar1
			// 
			this.progressBar1.Location = new System.Drawing.Point(40, 328);
			this.progressBar1.Name = "progressBar1";
			this.progressBar1.Size = new System.Drawing.Size(416, 16);
			this.progressBar1.TabIndex = 7;
			this.progressBar1.Visible = false;
			// 
			// panel3
			// 
			this.panel3.BackColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel3.Controls.Add(this.button2);
			this.panel3.Controls.Add(this.textBox2);
			this.panel3.Controls.Add(this.label4);
			this.panel3.Enabled = false;
			this.panel3.Location = new System.Drawing.Point(96, 200);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(384, 64);
			this.panel3.TabIndex = 6;
			// 
			// button2
			// 
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button2.Location = new System.Drawing.Point(296, 24);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(72, 24);
			this.button2.TabIndex = 2;
			this.button2.Text = "Browse";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// textBox2
			// 
			this.textBox2.Location = new System.Drawing.Point(8, 24);
			this.textBox2.Name = "textBox2";
			this.textBox2.Size = new System.Drawing.Size(280, 21);
			this.textBox2.TabIndex = 1;
			this.textBox2.Text = "";
			// 
			// label4
			// 
			this.label4.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label4.Location = new System.Drawing.Point(8, 8);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(128, 16);
			this.label4.TabIndex = 0;
			this.label4.Text = "T&humbnails folder:";
			// 
			// radioButton1
			// 
			this.radioButton1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButton1.Location = new System.Drawing.Point(64, 144);
			this.radioButton1.Name = "radioButton1";
			this.radioButton1.Size = new System.Drawing.Size(320, 16);
			this.radioButton1.TabIndex = 5;
			this.radioButton1.Text = "Store &thumbnails in a subfolder called \"thumbs\". (Default)";
			// 
			// button1
			// 
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button1.Location = new System.Drawing.Point(392, 96);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 24);
			this.button1.TabIndex = 4;
			this.button1.Text = "&Browse";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(64, 98);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(320, 21);
			this.textBox1.TabIndex = 3;
			this.textBox1.Text = "";
			// 
			// label3
			// 
			this.label3.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label3.Location = new System.Drawing.Point(64, 80);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(96, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "&Folder Location:";
			// 
			// label2
			// 
			this.label2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label2.Location = new System.Drawing.Point(40, 56);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(352, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "To create thumbnails for your images, follow the steps below.";
			// 
			// label1
			// 
			this.label1.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.label1.Font = new System.Drawing.Font("Tahoma", 15F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.Color.SkyBlue;
			this.label1.Location = new System.Drawing.Point(40, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(392, 24);
			this.label1.TabIndex = 0;
			this.label1.Text = "Create Thumbnails for images in a folder.";
			// 
			// radioButton2
			// 
			this.radioButton2.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.radioButton2.Location = new System.Drawing.Point(64, 176);
			this.radioButton2.Name = "radioButton2";
			this.radioButton2.Size = new System.Drawing.Size(320, 16);
			this.radioButton2.TabIndex = 5;
			this.radioButton2.Text = "Store thumbnails in a &custom folder.";
			this.radioButton2.CheckedChanged += new System.EventHandler(this.RadioCheckChanged);
			// 
			// panel2
			// 
			this.panel2.BackColor = System.Drawing.SystemColors.InactiveCaptionText;
			this.panel2.Controls.Add(this.button4);
			this.panel2.Controls.Add(this.btnCreate);
			this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panel2.Location = new System.Drawing.Point(0, 352);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(492, 56);
			this.panel2.TabIndex = 1;
			// 
			// button4
			// 
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.button4.Location = new System.Drawing.Point(392, 16);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(80, 24);
			this.button4.TabIndex = 1;
			this.button4.Text = "Exit";
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// btnCreate
			// 
			this.btnCreate.FlatStyle = System.Windows.Forms.FlatStyle.System;
			this.btnCreate.Location = new System.Drawing.Point(296, 16);
			this.btnCreate.Name = "btnCreate";
			this.btnCreate.Size = new System.Drawing.Size(80, 24);
			this.btnCreate.TabIndex = 0;
			this.btnCreate.Text = "Create";
			this.btnCreate.Click += new System.EventHandler(this.btnCreate_Click);
			// 
			// folderBrowserDialog1
			// 
			this.folderBrowserDialog1.Description = "Choose Images Folder";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(492, 408);
			this.Controls.Add(this.panel2);
			this.Controls.Add(this.panel1);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Generate Thumbnails";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.panel1.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e) {
			this.radioButton1.Checked = true;
			this.checkBox1.Checked = true;

			sd.ChosenHeight = maxHeight;
			sd.ChosenWidth = maxWidth;
		}

		private void RadioCheckChanged(object sender, System.EventArgs e) {
			if(radioButton2.Checked){
				panel3.Enabled = true;
			}
			else panel3.Enabled = false;
		}

		private void button1_Click(object sender, System.EventArgs e) {
			DialogResult dr =  folderBrowserDialog1.ShowDialog(this);
			if(dr.Equals(DialogResult.OK)){
				textBox1.Text = folderBrowserDialog1.SelectedPath;
			}
		}

		private void button2_Click(object sender, System.EventArgs e) {
			DialogResult dr =  folderBrowserDialog1.ShowDialog(this);
			if(dr.Equals(DialogResult.OK)){
				textBox2.Text = folderBrowserDialog1.SelectedPath;
			}
		
		}

		private void button4_Click(object sender, System.EventArgs e) {
			Application.Exit();
		}

		private void btnCreate_Click(object sender, System.EventArgs e) {

			lblDone.Visible = false;
			progressBar1.Value = 0;

			//TODO: insert a giant try catch here...

			string imagesPath = "", thumbsPath = "";


			//First check the values in the textBoxes...
			if(! Directory.Exists(textBox1.Text)){
				MessageBox.Show("Error: Folder does not exist");
				return;
			}
			imagesPath = textBox1.Text;

			//The destination folder...
			//check whether custom or not..
			if(radioButton2.Checked){//custom folder
				thumbsPath = textBox2.Text;
				if(!Directory.Exists(thumbsPath)){
					Directory.CreateDirectory(thumbsPath);
				}
			}
			else{//default subdirectory..
				thumbsPath = Path.Combine(imagesPath, "thumbs");
				if(!Directory.Exists(thumbsPath)){
					Directory.CreateDirectory(thumbsPath);
				}
			}

			progressBar1.Visible = true;

			makeThumbnails(imagesPath, thumbsPath);
		}


		private void makeThumbnails(string imagesPath, string thumbsPath){
			string[] files = Directory.GetFiles(imagesPath);

			progressBar1.Step = 100/files.Length;

			foreach(string f in files){
				progressBar1.PerformStep();


				string fullImagePath = Path.Combine(imagesPath,f);
				string bareImagePath = Path.GetFileName(f);


				//check whether it is an image - preliminary check
				if(
					".bmp .jpg .gif .jpeg .png .wmf".IndexOf(
					Path.GetExtension(fullImagePath).ToLower()
					) == -1
				) {
					continue;
				}

				//Check whether thumbnail already exists
				if(!refreshOldThumbnails){
					if(File.Exists(Path.Combine(thumbsPath, bareImagePath)))
						continue;
				}

				//Start attempting thumbnailing
//				try{
					Image bmp = Bitmap.FromFile(fullImagePath);

					//Compute the dimensions of the thumbnail...
					int height=0, width=0;
					findThumbSizes(bmp.Width, bmp.Height, ref width, ref height);

					Image thumb = bmp.GetThumbnailImage(width,height,null, IntPtr.Zero);
					thumb.Save(Path.Combine(thumbsPath,bareImagePath),System.Drawing.Imaging.ImageFormat.Jpeg);
//				}catch (Exception e){
//					MessageBox.Show(e.Message);
//				}

			}

			progressBar1.Visible = false;
			lblDone.Visible = true;
		}


		private void findThumbSizes(int bmpWidth, int bmpHeight, ref int width, ref int height){
			//First assume that the width will be the critical factor.
			double ratio = bmpWidth/(double)maxWidth;
			width = (int)(bmpWidth/ratio);
			height = (int)(bmpHeight/ratio);
			if(height<=maxHeight)return;

			//if Width was not the critical factor, 
			ratio = bmpHeight/(double)maxHeight;
			width = (int)(bmpWidth/ratio);
			height = (int)(bmpHeight/ratio);
		}

		private void linkLabel1_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e) {
			sd.ChosenHeight = maxHeight;
			sd.ChosenWidth = maxWidth;
			DialogResult dr = sd.ShowDialog(this);
			if(dr.Equals(DialogResult.OK)){
				maxHeight = sd.ChosenHeight;
				maxWidth = sd.ChosenWidth;
			}
		}

		private void overwriteCheckChanged(object sender, System.EventArgs e) {
			if(checkBox1.Checked)refreshOldThumbnails = true;
			else refreshOldThumbnails = false;
		}


	}
}
